// Initial Developer: 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp> 
// Author: Zijian Ren
// Version :1.20
// Date: Sep 19, 2003
// Comments: Add a messages collection
//		Add act() module
//	Add burning and human building collection


package phoenix;

import java.net.*;
import yab.agent.*;
import yab.agent.object.*;
import java.util.*;

public class AmbulanceCenterAgent extends AbstractAmbulanceCenterAgent {
    	//Collection of blockade roads. Data Stucture: id|messagebase
	private HashMap blockadeRoads = new HashMap(); //inform policeforces
	private HashMap burningBuildings = new HashMap(); //inform firebrigades
	private HashMap buriedBuildings = new HashMap(); //all buildings with buried humans
	private HashMap emptyBuildings = new HashMap();
		
    public AmbulanceCenterAgent(InetAddress address, int port) {
        super(address, port);
    }

    protected void act() throws ActionCommandException {
    	//System.out.println("time "+time()+" "+self()+burningBuildings);
				
	String body="";			
	
	body = Global.tellMessages(blockadeRoads, time());
	if (!body.equals("")) {
		String message = "time "+time()+" clear "+body;
		tell(message);
		
		boolean verbose = false;	
		if (verbose)
			System.out.println("Time "+time()+" "+self()+" Message: "+message);
	}
	
	body = Global.tellMessages(buriedBuildings, time());
	if (!body.equals("")) {
		String message = "time "+time()+" locate "+body;
		tell(message);
		
		boolean verbose = true;
		if (verbose)
			System.out.println("Time "+time()+" "+self()+" Message: "+message);
	}
		
	//old tell message
	tellMessages(emptyBuildings, "empty", true);
	tellMessages(burningBuildings, "extinguish", true);

    }

    
        protected void tellMessages(Map messages, String command, boolean verbose) throws ActionCommandException {
		String message = "time "+ time() +" "+command;
		String ids = "";
		
		for(Iterator it=messages.entrySet().iterator(); it.hasNext(); ) {
			Map.Entry e = (Map.Entry)it.next();
			if ( !((String)e.getValue()).equals("0") ) {
				ids += (" " + (String)e.getKey());
				//reset this message time stamp to 0
				e.setValue("0");
			}
		}
		
		if (!ids.equals("")) {
			tell(message+ids);
			
			if (verbose)
				System.out.println("Time "+time()+" "+self()+" Message: "+message+ids);
		}		
	}
        
    protected void hear(RealObject sender, String message) {
       //System.out.println("Time "+time()+" receiver "+self()+" sender "+sender+" "+message); 

       	//for huamn buildings information
	if (sender instanceof FireStation || sender instanceof PoliceOffice) {
		Global.processMessages(message, "locate", buriedBuildings, time());	
	
		StringTokenizer st = new StringTokenizer(message);
		st.nextToken(); //String "Time"
        	String time = st.nextToken();
		String command = st.nextToken();
		
		int degree = 1;
		if (command.equals("locate")) {

		} else if (command.equals("extinguish")) {
			//reset all fire messages
			while (st.hasMoreTokens()) {
				String id = st.nextToken();
				burningBuildings.put(id, "0");
			}	
		} else if (command.equals("clear")) {
				//Format: time x clear degree 5 y1 ... degree 1 z1 ....
				//reset all road messages
				/*while(st.hasMoreTokens()) {
					String s = st.nextToken();
					if (s.equals("degree")) {
						degree = Integer.parseInt(st.nextToken());
					} else {
						
					}
				}
				*/	
		} else if (command.equals("empty")) {

			while (st.hasMoreTokens()) {
				String id = st.nextToken();
				emptyBuildings.put(id, time);
			}
		}	
		
	} // end if
       
        if (sender instanceof AmbulanceTeam) {
		Global.processMessages(message, "locate", buriedBuildings, time());
		
		StringTokenizer st = new StringTokenizer(message);
		st.nextToken(); //string "time"
        	String time = st.nextToken();
		String command = st.nextToken();
		
		String id = st.nextToken();
		
		if (command.equals("extinguish")) {
			if (!burningBuildings.containsKey(id))
				burningBuildings.put(id, time);
		} else if (command.equals("clear")) {
			st.nextToken(); //String "degree"
			int degree = Integer.parseInt(st.nextToken());
			
			if (!blockadeRoads.containsKey(id)) {
				MessageBase mb = new MessageBase(time(), degree);
				blockadeRoads.put(id, mb);
				
			} else {
				MessageBase mb = (MessageBase)blockadeRoads.get(id);
				if (degree > mb.degree) {
					mb.setValue(time(), degree);
				}	
			}	
		
		} else if (command.equals("locate")) {
		
		} else if (command.equals("empty")) {
			if (!emptyBuildings.containsKey(id))
				emptyBuildings.put(id, time);
		}					
	} // end if
	
    } //end hear()
}

