// Author: Zijian Ren
// Version :1.10
// Date: Feb 19, 2004
// Comments: check the maximum bytes of the body.


package phoenix;

import java.util.*;

public class Global {
        static String tellMessages(Map messages, int time) {
	//System.out.println("messages map "+messages);			
		//five degree IDs: 5,4,3,2, and 1.
		String[] ids = new String[6];
		for(int i=0; i<6; i++)
			ids[i] = "";
		
		for(Iterator it=messages.entrySet().iterator(); it.hasNext(); ) {
			Map.Entry e = (Map.Entry)it.next();
			MessageBase mb = (MessageBase)e.getValue();
			
			if ( mb.unSent() ) {
				ids[mb.degree] += (" " + (String)e.getKey());
				mb.setSendTime(time);
			}
		}
		
		String body = "";
		for(int degree=5; degree>=1; degree--) {
			String oldBody = body;
			if (!ids[degree].equals("")) {
				body += " degree " + degree + ids[degree]; 
			}
			
			if (body.length() >= maxBytesOneMessage)
				return oldBody;
		}
		
		return body;
	} // end of tellMessages()

	//the message format should be "Time t Command degree 5 x1 ... degree 1 y1"
	static void processMessages(String message, String command, HashMap hmap, int sysTime) {
		StringTokenizer st = new StringTokenizer(message);
		st.nextToken(); //String "Time"
        	String time = st.nextToken();
		
		if (!command.equals(st.nextToken()))
			return;
		
		int degree = 1;
		while(st.hasMoreTokens()) {
			String s = st.nextToken();
			if (s.equals("degree")) {
				degree = Integer.parseInt(st.nextToken());
			} else {
				//s is id
				if (!hmap.containsKey(s)) {
					MessageBase mb = new MessageBase(sysTime, degree);
					hmap.put(s, mb);
				} else {
					MessageBase mb = (MessageBase)hmap.get(s);
					if (degree > mb.degree) {
						mb.setValue(sysTime, degree);
					}	
				}	
				
			}		
			
		} //end while
	
	} //end of processMessage()
	
	
	static final int CycleAgentFreeze = 3;
	static final int CycleFarFireInvisible = 5;

	static final int maxBytesOneMessage = 256;
	
	//For Kobe city, may read from a file
	static final int Kobe_landmarkBuildings[] = {2104, 1604, 2247, 1765, 1726, 2066, 2185, 1698, 1700};
	//int landmarkRoads[] = {735, 64, 257, 698, 320, 617, 700, 163, 615, 219, 109, 424, 520, 14, 706}; //, 113};
	//new landmark only in narrow roads
	static final int Kobe_landmarkRoads[] = {320, 617, 109, 424, 520, 706};	

	//For Virtual City, may read from a file
	static final int VC_landmarkBuildings[] = {1507, 2221, 2349, 1304, 1258, 2106, 1300, 1755,
						   1966, 2018, 1722, 2405, 1339, 1241, 1932, 1731};
	static final int VC_landmarkRoads[] = {443, 422, 566, 611, 336, 359, 491, 528,
						106, 20, 234, 291, 125, 622, 155, 214};	
}
