// Initial Developer: 2002 Takeshi Morimoto <morimoto@takopen.cs.uec.ac.jp> 
// Author: Zijian Ren
// Version :1.10
// Date: Sep 17, 2003
// Comments: Add act()                                                                    


package phoenix;

import java.net.*;
import yab.agent.*;
import yab.agent.object.*;
import java.util.*;

public class PoliceOfficeAgent extends AbstractPoliceOfficeAgent {

	private HashMap blockadeRoads = new HashMap();
	private HashMap clearRoads = new HashMap();
	private HashMap buriedBuildings = new HashMap(); //all buildings with buried humans
	private HashMap burningBuildings = new HashMap(); //all buildings with buried humans
		
    public PoliceOfficeAgent(InetAddress address, int port) {
        super(address, port);
    }

    protected void act() throws ActionCommandException {

					
	String body = Global.tellMessages(blockadeRoads, time());
	if (!body.equals("")) {
		String message = "time "+time()+" clear "+body;
		tell(message);
		
	    	boolean verbose = true;
		if (verbose)
			System.out.println("Time "+time()+" "+self()+" Message: "+message);
	}			
	
	tellMessages(clearRoads, "remove", true);
	
	tellMessages(burningBuildings, "extinguish", false);
		
	tellMessages(buriedBuildings, "locate", false);	

    }
    
        protected void tellMessages(Map messages, String command, boolean verbose) throws ActionCommandException {
		String message = "time "+ time() +" "+command;
		String ids = "";
		
		for(Iterator it=messages.entrySet().iterator(); it.hasNext(); ) {
			Map.Entry e = (Map.Entry)it.next();
			if ( !((String)e.getValue()).equals("0") ) {
				ids += (" " + (String)e.getKey());
				//reset this message time stamp to 0
				e.setValue("0");
			}
		}
		
		if (!ids.equals("")) {
			tell(message+ids);
			
			if (verbose)
				System.out.println("Time "+time()+" "+self()+" Message: "+message+ids);
		}		
	}
		
    protected void hear(RealObject sender, String message) {
    	//System.out.println("Time "+time()+" receiver "+self()+" sender "+sender+" "+message);
        if (sender instanceof FireStation || sender instanceof AmbulanceCenter) {
		StringTokenizer st = new StringTokenizer(message);
		st.nextToken();
        	String time = st.nextToken();
		//three commands: clear, locate, and extinguish 
		String command = st.nextToken();
		
		int degree = 1;
		if (command.equals("clear")) {
			
			//clear degree 5 x1 x2 ... degree 1 y1 y2  
			while(st.hasMoreTokens()) {
				String s = st.nextToken();
				if (s.equals("degree")) {
					degree = Integer.parseInt(st.nextToken());
				} else {
					//s is id
					if (!blockadeRoads.containsKey(s)) {
						MessageBase mb = new MessageBase(time(), degree);
						blockadeRoads.put(s, mb);
				
					} else {
						MessageBase mb = (MessageBase)blockadeRoads.get(s);
						if (degree > mb.degree) {
							mb.setValue(time(), degree);
						}	
					}	
				
				}		
			
			} //end while
			
			
		} else if (command.equals("locate")) {
			/*while (st.hasMoreTokens()) {
				String id = st.nextToken();
				buriedBuildings.put(id, "0");
			}*/	
		} else if (command.equals("extinguish")) {
				//rest all messages
			while (st.hasMoreTokens()) {
				String id = st.nextToken();
				burningBuildings.put(id, "0");
			}	
		}
			
		

	
	} //end sender
	 
	 
	
	if (sender instanceof PoliceForce) {
		StringTokenizer st = new StringTokenizer(message);
		st.nextToken();
        	String time = st.nextToken();
		String command = st.nextToken();
		//so far, NO clear message from police forces
		
		while (st.hasMoreTokens()) {
			String id = st.nextToken();
		
			if (command.equals("locate")) {
				if (!buriedBuildings.containsKey(id)) {
					buriedBuildings.put(id, time);
				}	
			} else if (command.equals("extinguish")) {
				if (!burningBuildings.containsKey(id)) {
					burningBuildings.put(id, time);
				}
			} else if (command.equals("remove")) {
				if (!clearRoads.containsKey(id)) {
					clearRoads.put(id, time);
				}
			}	
		}			 
	} // end if	
    } //end hear()
}
